/**** Simple NIOS I/O Examples ****/

/* Scroll a message across the HEX display. */

.include "ubc-de1media-macros.s"

.equ DIGITBLANK,	0x00
.equ ALLBLANK,	0x00000000

.global _start

.text
_start:		movia	r23, IOBASE			/* use r23 as base register for I/O operations */

			movia	r8, ALLBLANK		/* initialize hex display, all "OFF" */
			stwio	r8, HEX7SEG(r23)

			movia	r10, TABLE_END
reset:		movia	r9, TABLE_START

loop:		ldwio	r11, 0(r9)			/* read next digit from table */

			slli	r8, r8, 8			/* shift all digits one position left */
			or	r8, r8, r11			/* OR in value for next digit (next 8 bits) */

			stwio	r8, HEX7SEG(r23)
			call	delay

			/* advance to next digit in table */
			addi	r9, r9, 4
			bne	r9, r10, loop		/* not at table end, shift in next table entry */

			br	reset				/* at table end, start over with first table entry */


			/* delay subroutine */
delay:		movia	r2, 5000000			/* count from 5,000,000 for ~0.2s delay */
delay_loop:	subi	r2, r2, 1
			bne	r2, r0, delay_loop	/* delay by counting down to 0 */
			ret

.data

TABLE_START:
.word DIGITE, DIGITE, DIGITC, DIGITE
.word DIGIT0, DIGIT2, DIGIT5, DIGIT9
.word DIGITBLANK
.word DIGITC, DIGITA, DIGITF, DIGITE
.word DIGITB, DIGITA, DIGITB, DIGITE
.word DIGITBLANK
TABLE_END:

.end
